/*
 * Gtk-IPtables is Copyright (C) 2006  Daniel E. Testa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _CREATE_RULE_WIN_H_
#define _CREATE_RULE_WIN_H_

#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "gtkipt_utils.h"

#define TABLE_FILTER "filter"
#define TABLE_NAT    "nat"
#define TABLE_MANGLE "mangle"

#define CHAIN_SEP_FILTER  "--Filter--"
#define CHAIN_SEP_NAT     "--Nat-----"
#define CHAIN_SEP_MANGLE  "--Mangle--"

#define CHAIN_ITM_INPUT       "INPUT"
#define CHAIN_ITM_FORWARD     "FORWARD"
#define CHAIN_ITM_OUTPUT      "OUTPUT"
#define CHAIN_ITM_PREROUTING  "PREROUTING"
#define CHAIN_ITM_POSTROUTING "POSTROUTING"

#define PROTO_TCP  "tcp"
#define PROTO_UDP  "udp"
#define PROTO_ICMP "icmp"

#define JUMP_ACCEPT "ACCEPT"
#define JUMP_DROP   "DROP"
#define JUMP_QUEUE  "QUEUE"
#define JUMP_RETURN "RETURN"
#define JUMP_REJECT "REJECT"

#define BIG_STRING 512

gint ins_add_op;
gint rule_number;

gint state_settcp_f = 0;
gint state_settcp_o = 0;
gint state_settcp_m = 0;
gint state_settcp_s = 0;

gchar settcp_buf[40];
gchar seticmp_buf[50];
gchar setreject_buf[50];
gchar logrule_buf[40];

void on_cb_chains_changed(GtkWidget *widget, gpointer data);
void on_cb_protocol_changed(GtkWidget *widget, gpointer data);
void on_bt_tcp_clicked(GtkWidget *widget, gpointer data);
void on_bt_icmp_clicked(GtkWidget *widget, gpointer data);
void sport_callback(GtkWidget *widget, gpointer data);
void saddr_callback(GtkWidget *widget, gpointer data);
void daddr_callback(GtkWidget *widget, gpointer data);
void dport_callback(GtkWidget *widget, gpointer data);
void jump_callback(GtkWidget *widget, gpointer data);
void ininter_callback(GtkWidget *widget, gpointer data);
void outinter_callback(GtkWidget *widget, gpointer data);
void pkts_func(GtkWidget *widget, gpointer data);
void bytes_func(GtkWidget *widget, gpointer data);
int make_command_line();
void on_bt_accept_clicked(GtkWidget *widget, gpointer data);
void on_chk_fragment_clicked(GtkWidget *widget, gpointer data);
void on_chk_frag_w_options_clicked(GtkWidget *widget, gpointer data);


#endif /* _CREATE_RULE_WIN_H_ */


