/*
 * Gtk-IPtables is Copyright (C) 2006  Daniel E. Testa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "gtkipt_utils.h"

GtkWidget *png_label_box(gchar *png_filename, gchar *label_text)
{
    GtkWidget *box;
    GtkWidget *label;
    GtkWidget *image;

    /* Create box for image and label */
    box = gtk_hbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (box), 0);

    /* Now on to the image stuff */
    image = gtk_image_new_from_file (png_filename);

    /* Create a label for the button */
    label = gtk_label_new (label_text);

    /* Pack the image and label into the box */
    gtk_box_pack_start (GTK_BOX (box), image, FALSE, FALSE, 5);
    gtk_box_pack_start (GTK_BOX (box), label, FALSE, TRUE, 0);

    gtk_widget_show (image);
    gtk_widget_show (label);

    return box;
}

char* left_trim(char *p_text)
{
  if (p_text)
    {
      while (isspace(*p_text))
	p_text++;
    }
	
  return p_text;
}

int message_box(GtkWindow *parent, const char *p_msg, GtkMessageType type, 
		GtkButtonsType buttons)
{
  GtkWidget *dialog;
  int n_ret_val = -1;

  dialog = gtk_message_dialog_new (parent,
				   GTK_DIALOG_DESTROY_WITH_PARENT,
				   type,
				   buttons,
				   p_msg);

  n_ret_val = (int)gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);

  return n_ret_val;
}

int get_list_selected_row(GtkWidget *clist)
{
  GList *list = NULL;
  int n_count = (int)GTK_CLIST(clist)->rows;
  int n_index = 0;
  int n_ret = -1;

  for(n_index = 0; n_index < n_count; n_index++)
    {
      list = g_list_nth(GTK_CLIST(clist)->row_list, n_index);
      
      if(GTK_CLIST_ROW(list)->state == GTK_STATE_SELECTED)
	{
	  n_ret = n_index;
	  break;
	}
    }

  return n_ret;
}

int have_root_access()
{
  int n_ret_val = FALSE;
  char s_curr_user[16];
  FILE *p_cmd = NULL;

  p_cmd = popen("id -nu", "r");
  fscanf(p_cmd, "%s", &s_curr_user);

  if (strcmp("root", s_curr_user) == 0)
    n_ret_val = TRUE;

  pclose(p_cmd);
  
  return n_ret_val;
}
